Subject: comp.specification.z Frequently Asked Questions (Monthly)
From: [email-masked]
Date: Sun, 1 May 1994 01:00:05 GMT
Newsgroups: comp.specification.z,news.answers,comp.answers

Archive-name: z-faq
Last-modified: 11 April 1994

NAME:     comp.specification.z
STATUS:   unmoderated
PURPOSE:  Discussion concerning the formal specification notation Z.

(If you have read this before, changed and new sections since the
previously issued version are marked with `|' in the right hand margin.)

Questions have been marked with "Subject:" at the start of the line to
allow some newsreaders to scan them easily (e.g., "^G" within "rn").
This FAQ message is available on-line on the World Wide Wed (WWW) hypertext  |
http://www.cis.ohio-state.edu/hypertext/faq/usenet/z-faq/faq.html page       |
where it is split into convenient sections.                                  |

Subject: What is it?

The comp.specification.z electronic USENET newsgroup was established in
June 1991 and is intended to handle messages concerned with the formal
specification notation Z (pronounced `zed'). It has an estimated
readership of around 30,000 people worldwide.  Z, based on set theory
and first order predicate logic, has been developed at the Programming
Research Group (PRG) at the Oxford University Computing Laboratory and
elsewhere for well over a decade.  It is now used by industry as part
of the software (and hardware) development process in both the UK and
the US. It is currently undergoing BSI standardization in the UK and
has been accepted for the ISO standardization process internationally.
Comp.specification.z provides a convenient forum for messages concerned
with recent developments and the use of Z.  Pointers to and reviews of
recent books and articles are particularly encouraged. These will be
included in the Z bibliography (see below) if they appear in
comp.specification.z.

Subject: What if I know someone interested without access to USENET news?

There is an associated Z FORUM electronic mailing list that was
initiated in January 1986 by Ruaridh Macdonald, RSRE, UK.  Articles are
now automatically cross-posted between comp.specification.z and the
mailing list for those whose do not have access to USENET news.  This
may apply especially to industrial Z users who are particularly
encouraged to subscribe and post their experiences to the list.  Please
contact <[email-masked]> with your name, address and
email address to join the mailing list (or if you change your email
address or wish to be removed from the list). Readers are strongly
urged to read the comp.specification.z newsgroup rather than the Z
FORUM mailing list if possible. Messages for submission to the Z FORUM
mailing list and the comp.specification.z newsgroup may be emailed to
<[email-masked]>.  This method of posting is particularly
recommended for important messages like announcements of meetings since
not all messages posted on comp.specification.z reach the PRG.

Subject: What if I know someone interested without access to email?

If you wish to join the postal Z mailing list, please send your address
to Anthony Hall, Praxis Systems plc, 20 Manvers Street, Bath BA1 1PX,
UK  (tel +44-225-444700, fax +44-225-465205, email <[email-masked]>).
This will ensure you receive details of Z meetings, etc., particularly
for people without access to electronic mail.

Subject: How can I join in?

If you are currently using Z, you are welcome to introduce yourself to
the newsgroup and Z FORUM list by describing your work with Z or
raising any questions you might have about Z which are not answered
here. You may also advertize publications concerning Z which you or
your colleagues produce. These may then be added to the master Z
bibliography maintained at the PRG (see below).

Subject: Where are Z-related files archived?

There is an automatic electronic mail-based electronic archive server
at the PRG which contains most messages and back-issues on
comp.specification.z and Z FORUM, as well as a selection of other
Z-related files.  Send an email message containing the command "help"
to <[email-masked]> for further information on how to
use the server. A command of "index z" will list the Z-related files.
If you have serious trouble accessing the archive server, please
contact the address <[email-masked]>.
  The archive is also available via anonymous FTP on the Internet
under the ftp.comlab.ox.ac.uk:/pub/Zforum directory. Type the                |
command "ftp ftp.comlab.ox.ac.uk" (or alternatively "ftp 163.1.27.2"
if this does not work) and use "anonymous" as the login id and your
email address as the password when prompted. The FTP command
"cd pub/Zforum" will get you into the Z archive directory.  The file
ftp.comlab.ox.ac.uk:/pub/Zforum/README gives some general information        |
and ftp.comlab.ox.ac.uk:/pub/Zforum/00index gives a list of the              |
files.  (Retrieve these using the FTP command "get README", for
example.)
  Information on the World Wide Web (WWW) will be available shortly on       |
the http://www.comlab.ox.ac.uk/archive/zforum.html page.  See also the       |
http://www.comlab.ox.ac.uk/archive/formal-methods.html page on formal        |
methods in general. The WWW global hypertext system is accessible using      |
the "mosaic" or "lynx" programs for example. Contact your system manager     |
if WWW access is not available on your system.                               |

Subject: What tools are available?

Various tools for formatting, type-checking and aiding proofs in Z are
available.  A free LaTeX style file and documentation can be obtained
from the PRG archive server. To receive this via email, send a message
containing the command "send z zed.sty zguide.tex" to the PRG archive
server (or access the ftp.comlab.ox.ac.uk:/pub/Zforum/zed.sty and            |
ftp.comlab.ox.ac.uk:/pub/Zforum/zguide.sty files). A newer style             |
"csp_zed.sty" is also available in the same location, which uses the new     |
font selection scheme and covers CSP and Z symbols.
  The fuzz package, a syntax and type checker with a LaTeX style option
and fonts, is available from J.M. Spivey Computing Science Consultancy,
34, Westlands Grove, Stockton Lane, York YO2 0EF, UK. It is compatible
with the second edition of Spivey's Z Reference Manual (see below).
Contact Mike Spivey (email <[email-masked]>) for
further information. Alternatively send the command "send z fuzz" to
the PRG archive server or access ftp.comlab.ox.ac.uk:/pub/Zforum/fuzz        |
for brief information and an order form.
  CADiZ, a suite of tools for checking and typesetting Z specifications
is available from York Software Engineering, University of York, York
YO1 5DD, UK (tel +44-904-433741, fax +44-904-433744). Support is
available for Unix troff and more recently for LaTeX. Further information
is available from David Jordan at York on <[email-masked]>.
  ProofPower is a suite of tools supporting specification and proof in
Higher-Order Logic (HOL) and in Z. Short courses on ProofPower-Z are
available as demand arises.  Information about ProofPower can be
obtained automatically from <[email-masked]>.  Contact
Roger Jones, International Computers Ltd, Eskdale Road, Winnersh,
Wokingham, Berkshire RG11 5TT, UK (tel +44-734-693131 ext 6536, fax
+44-734-697636, email <[email-masked]> or
<[email-masked]>) for further details.
  Zola is a tool that supports the production and typesetting of Z
specifications, including a type-checker and a Tactical Proof System.
The tool is sold commercially and available to academic users at a
special discount.  For further information, contact K. Ashoo, Imperial
Software Technology, 62-74 Burleigh Street, Cambridge CB1 1DJ, UK (tel
+44-223-462400, fax +44-223-462500, email <[email-masked]>).
  ZTC is a Z type checker for the PC and Sun available free of charge         |
via anonymous FTP in compressed Unix tar format under the directory           |
ise.cs.depaul.edu:/dist (140.192.32.117) and also from the Z archive at       |
Oxford under the ftp.comlab.ox.ac.uk:/pub/Zforum/ZTC-1.3 directory.  It       |
is available for educational and non-profit uses and is part of an            |
ongoing research project developing supporting tools for using Z.             |
Contact Xiaoping Jia on <[email-masked]> for further information.          |
  Formaliser is a syntax-directed Z editor and type checker, running
under Microsoft Windows, available from Logica Cambridge.  Contact
Susan Stepney, Logica Cambridge Limited, Betjeman House, 104 Hills Road,
Cambridge CB2 1LQ, UK  (tel +44-223-66343, email <[email-masked]>)
for further information.
  DST-fuzz is a set of tools based on the fuzz package by Mike Spivey,        |
supplying a Motif based user interface for LaTeX based pretty printing,       |
syntax and type checking. A CASE tool interface allows basic                  |
functionality for combined application of Z together with structured          |
specifications. The tools are integrated into SoftBench. For further          |
information contact Hans-Martin Hoercher, DST Deutsche System-Techik          |
GmbH, Edisonstr. 3, D-24145 Kiel, Germany (tel +49-(0)431-7109-478, fax       |
+49-(0)431-7109-503, email <[email-masked]>).                |
  The B-Tool can be used to check proofs concerning parts of Z
specifications.  This is licensed by Edinburgh Portable Compilers Ltd,
17 Alva Street, Edinburgh EH2 4PH, UK (tel +44-31-225-6262, fax
+44-31-225-6644). Contact the Distribution Manager (email
<[email-masked]>) for further information.
  The B-Toolkit is a set of integrated tools which fully supports the
B-Method for formal software development and is available from B-Core
(UK) Limited, Magdalen Centre, The Oxford Science Park, Oxford OX4 4GA,
UK. For further details, contact Ib Sorensen (tel +44-865-784520,
fax +44-865-784518, email <[email-masked]>).
  A survey of Z tools may be obtained from Colin Parker, Systems Process
Department, W376C, British Aerospace, Warton Aerodrome, Warton, Preston
PR4 1AX, UK.

Subject: How can I learn about Z?

There are a number of courses on Z run by industry and academia. Oxford
University offers industrial short courses in the use Z.  As well as
introductory courses, recent newly developed material includes advanced
Z-based courses on proof and refinement, partly based around the
B-Tool.  Courses are held in Oxford, or elsewhere (e.g., on a company's
premises) if there is enough demand. For further information, contact
Jim Woodcock (tel +44-865-283514, fax +44-865-273839, email
<[email-masked]>).
  Logica Cambridge Limited offer a five day course on Z and a three day
introductory course on formal methods (mainly Z).  For dates and prices
contact Debi Kearney on +44-223-66343 ext 4859.
  Praxis Systems plc runs a range of Z (and other formal methods) courses.
For details contact Anthony Hall on +44-225-444700 or <[email-masked]>.
  Formal Systems (Europe) Ltd run a range of Z, CSP and other formal
methods courses, primarily in the US and with such lecturers as Jim
Woodcock and Bill Roscoe (both lecturers at the PRG).  For dates and prices
contact Joy Reed (tel +44-865-283503, email <[email-masked]>)
at the PRG or Kate Pearson (tel +44-865-728460) at Formal Systems.
  DST Deutsche System-Technik runs a collection of courses for either Z       |
or CSP, mainly in Germany. These courses range from half day                  |
introductions to formal methods and Z to one week introductory or             |
advanced courses, held either at DST, or elsewhere.  For further              |
information contact Hans-Martin Hoercher, DST Deutsche System-Techik          |
GmbH, Edisonstr. 3, D-24145 Kiel, Germany (tel +49-(0)431-7109-478, fax       |
+49-(0)431-7109-503, email <[email-masked]>).                |

Subject: What has been published about Z?

A compressed BibTeX bibliography of Z-related publications is available
from the PRG archive under ftp.comlab.ox.ac.uk:/pub/Zforum/z.bib.Z (and      |
ftp.comlab.ox.ac.uk:/pub/Zforum/z.ps.Z in PostScript format).                |
Information on Oxford University Programming Research Group (PRG)
Technical Monographs and Reports, including many on Z, is available
from the librarian (tel +44-865-273837, fax +44-865-273839, email
<[email-masked]>).
  "Formal Methods: A Survey" by S.Austin & G.I.Parkin, March 1993
includes information on the use and teaching of Z in industry and
academia.  Contact DITC Office, Formal Methods Survey, National
Laboratory, Teddington, Middlesex TW11 0LW, UK (tel +44-81-943-7002,
fax +44-81-977-7091) for a copy.
  The following books largely concerning Z have been or are due to be
published (in approximate chronological order):

  I.Hayes (ed.), Specification case studies, Prentice Hall International
      Series in Computer Science, 1987. (2nd ed., 1993)
  J.M.Spivey, Understanding Z: a specification language and its formal
      semantics, Cambridge University Press, 1988.
  D.Ince, An introduction to discrete mathematics and formal system
      specification, Oxford University Press, 1988. (2nd ed., 1992)
  J.C.P.Woodcock & M.Loomes, Software engineering mathematics, Pitman, 1988.
  J.M.Spivey, The Z notation: a reference manual, Prentice Hall
      International Series in Computer Science, 1989. (2nd ed., 1992)
      [Widely used as the current de facto standard for Z.]
  A.Diller, Z: an introduction to formal methods, Wiley, 1990.
  J.E.Nicholls (ed.), Z user workshop, Oxford 1989, Springer-Verlag,
      Workshops in Computing, 1990.
  B.Potter, J.Sinclair & D.Till, An introduction to formal specification
      and Z, Prentice Hall International Series in Computer Science, 1991.
  D.Lightfoot, Formal specification using Z, MacMillan, 1991.
  A.Norcliffe & G.Slater, Mathematics for software construction,
      Ellis Horwood, 1991.
  J.E.Nicholls (ed.), Z user workshop, Oxford 1990, Springer-Verlag,
      Workshops in Computing, 1991.
  I.Craig, The formal specification of advanced AI architectures,
      Ellis Horwood, 1991.
  M.Imperato, An introduction to Z, Chartwell-Bratt, 1991.
  J.B.Wordsworth, Software development with Z, Addison-Wesley, 1992.
  S.Stepney, R.Barden & D.Cooper (eds.), Object orientation in Z,
      Springer-Verlag, Workshops in Computing, August 1992.
  J.E.Nicholls (ed.), Z user workshop, York 1991, Springer-Verlag,
      Workshops in Computing, 1992.
  D.Edmond, Information Modeling: Specification and Implementation,
      Prentice Hall, 1992.
  J.P.Bowen & J.E.Nicholls (eds.), Z user workshop, London 1992,
      Springer-Verlag, Workshops in Computing, 1993.
  S.Stepney, High integrity compilation: A case study, Prentice Hall, 1993.
  M.McMorran & S.Powell, Z guide for beginners, Blackwell Scientific, 1993.
  K.C.Lano & H.Haughton (eds.), Object-oriented specification case studies,
      Prentice Hall International Object-Oriented Series, 1993.
  B.Ratcliff, Introducing Specification Using Z: A Practical Case Study      |
      Approach, McGraw-Hill, 1994.                                           |
Announced:
  A.Diller, Z: an introduction to formal methods, 2nd ed., Wiley, c May 1994.
      (In preparation)
  J.P.Bowen & J.A.Hall (eds.), Z user workshop, Cambridge 1994,
      Springer-Verlag, Workshops in Computing, June 1994.
  J.C.P.Woodcock, Using standard Z, Prentice Hall International Series
      in Computer Science, 1994? (In preparation)
  R.Barden, S.Stepney, D.Cooper, Z in practice (A methods handbook for Z),
      Prentice-Hall, 1994. (In preparation)

Subject: What is object-oriented Z?

Several object-oriented extensions to or versions of Z have been
proposed.  The book "Object orientation in Z", listed above, is a
collection of papers describing various OOZ approaches - Hall, ZERO,
MooZ, Object-Z, OOZE, Schuman&Pitt, Z++, ZEST and Fresco (an OO VDM
method) - in the main written by the methods' inventors, and all
specifying the same two examples. A more recent book entitled
"Object-oriented specification case studies" surveys the principal
methods and languages for formal object-oriented specification,
including Z-based approaches.

Subject: How can I run Z?

Z is a (non-executable in general) specification language, so there is
no such thing as a Z compiler/linker/etc. as you would expect for a
programming language. Some people have looked at animating subsets of Z
for rapid prototyping purposes, using logic and functional programming
for example, but this work is preliminary and is not really the major
point of Z, which is to increase human understandability of the
specified system and allow the possibility of formal reasoning and
development. However, Prolog seems to be the main favoured language for
Z prototyping and some references may be found in the Z bibliography
(see above).

Subject: Where can I meet other Z people?
 
The 7th annual Z User Meeting with an industrial theme was held on
14-15 December 1992 at the DTI A preprint proceedings and draft Z
standard were distributed to delegates. A published proceedings is in
press; ordering details are available from the Z archive (see above) in
the ftp.comlab.ox.ac.uk:/pub/ZForum/zum92 file (also in PostScript           |
under the ftp.comlab.ox.ac.uk:/pub/ZForum/zum92.ps.Z file). An 8th           |
meeting (ZUM'94) is planned for 29-30 June 1994 at St. John's College,
University of Cambridge, UK in association with BCS FACS. A Call for
Participation is available in the Z archive (see above) in the
ftp.comlab.ox.ac.uk:/pub/ZForum/zum94 file (also in PostScript under         |
the ftp.comlab.ox.ac.uk:/pub/ZForum/zum94.ps.Z file and an A4 poster         |
in the ftp.comlab.ox.ac.uk:/pub/ZForum/zum94-poster.ps.Z file). For          |
general enquiries, contact the Conference Chair, Jonathan Bowen (tel
+44-865-283512, fax +44-865-273839, email <[email-masked]>).
  The 6th Refinement Workshop was held at City University, London, UK,
5-7 January 1994. The Programme Chair was David Till, Dept of Computer
Science, City University, Northampton Square, London, EC1V 0HB, UK (tel
+44-71-477-8552, email <[email-masked]>).  The proceedings for these
workshops are currently published in the Springer-Verlag Workshops in
Computing series.
  The first FME (Formal Methods Europe) Symposium was held in Odense,
Denmark, 19-23 April 1993.  The proceedings are available as Springer
LNCS 670. The next FME Symposium will be held 24-28 October 1994 in
Barcelona, Spain.  The Programme Chair is Tim Denvir (tel +44-81-882-5853,
fax +44-81-8823118, email <[email-masked]>) and the
Organizing Chair in Spain is Daniel Cabedo (tel +34-3-290-2400, fax
+34-3-290-2416, email <[email-masked]>). The chairman of
FME is Martyn Thomas, Praxis plc, 20 Manvers Street, Bath BA1 1PX, UK
(tel +44-225-444700, email <[email-masked]>).
  FORTE addresses formal techniques and testing methodologies
applicable to distributed systems such as Estelle, Lotos, SDL, ASN.1,
Z, etc.  FORTE'93 was held at Boston, Massachusetts, USA on 26-29
October 1993.  The IFIP WG6.1 7th International Conference on Formal
Description Techniques for Distributed Systems and Communications
Protocols will be held at Berne, Switzerland, 4-7 October 1994.  For
further information contact:  FORTE'94 Organization Committee,
University of Berne, PO Box 900, CH-3000 Bern 9, Switzerland (tel
+41-31-631-4994 (Dieter Hogrefe), -4430 (Stefan Leue), fax -3965, email
<[email-masked]>). Additional information is available via anonymous
FTP from the host "siam.unibe.ch" under the directory "forte94" (see the
file "README" first).
  Details of Z-related meetings may be advertized on comp.specification.z
if desired. All the above meetings are likely to be repeated in some form.

Subject: What is the Z User Group?

The Z User Group was set up in 1992 to oversee Z-related activities, and
the Z User Meetings in particular.  As a subscriber to comp.specification.z,
ZFORUM or the postal mailing list, you may consider yourself a member
of the Z User Group.  There are currently no charges for membership,
although this is subject to review if necessary.  Contact
<[email-masked]> for further information.

Subject: How can I obtain the draft Z standard?

The proposed Z standard under ISO/IEC JTC1/SC22 is available
electronically via anonymous FTP *only* (not via the mail server since
it is too large) from the Z archive at Oxford in compressed PostScript
format.  Version 1.0 of the draft standard is accessible as the file
ftp.comlab.ox.ac.uk:/pub/Zforum/zstandard1.0.ps.Z together with a annex      |
in the ftp.comlab.ox.ac.uk:/pub/Zforum/zstandard-annex1.0.ps.Z file.         |
It is also available in printed form from the Oxford University
Computing Laboratory librarian (tel +44-865-273837, fax +44-865-273839,
email <[email-masked]>) by requesting Technical Monograph
number PRG-107.

Subject: Where else is Z discussed?

The BCS FACS (British Computer Society Formal Aspects of Computer
Science special interest group) and FME (Formal Methods Europe) are two
organizations interested in formal methods in general. Contact BCS
FACS, Dept of Computer Studies, Loughborough University of Technology,
Loughborough, Leicester LE11 3TU, UK (tel +44-509-222676, fax
+44-509-211586, email <[email-masked]>) for further information. A
"FACS Europe" newsletter is issued to members of FACS and FME.  Please
send suitable Z-related material to the Z column editor, David Till,
Dept of Computer Science, City University, Northampton Square, London,
EC1V 0HB, UK (tel +44-71-477-8552, email <[email-masked]>) for
possible publication.  Material from articles appearing on the
comp.specification.z newsgroup may be included if considered of
sufficient interest (with permission from the originator if possible).
It would be helpful for posters of articles on comp.specification.z to
indicate if they do not want further distribution for any reason.

Subject: How does VDM compare with Z?

See I.J.Hayes, C.B.Jones & J.E.Nicholls, Understanding the differences
between VDM and Z, FACS Europe, series I, 1(1):7-30, Autumn 1993
available as an on-line Technical Report from Manchester under               |
ftp.cs.man.ac.uk:/pub/TR/UMCS-93-8-1.ps.Z and I.J.Hayes, VDM and Z: A        |
comparative case study, Formal Aspects of Computing, 4(1):76-99, 1992.
VDM is discussed on the (unmoderated) VDM FORUM mailing list. Send a
message containing the command "join vdm-forum <name>" where <name> is
your real name to <[email-masked]>. To contact the list
administrator, email John Fitzgerald at the University of Newcastle
upon Tyne, England, on <[email-masked]>.

Subject: What if I have spotted a mistake or an omission?

Please send corrections or new relevant information about meetings,
books, tools, etc., to <[email-masked]>.  New questions
and model answers are also gratefully received!

--
Jonathan Bowen, <[email-masked]>
Programming Research Group, Oxford University Computing Laboratory, UK.